=== debian/changelog ===
trilinos (13.2.0-5build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:11:29 +1100

trilinos (13.2.0-5build1) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:38:26 +0000

trilinos (13.2.0-5) unstable; urgency=medium

  * Include missing headers to fix build with GCC-13 (Closes: #1037874)

 -- Graham Inggs <ginggs@debian.org>  Mon, 04 Sep 2023 16:41:09 +0000

trilinos (13.2.0-4) unstable; urgency=medium

  * Team upload.

  [ Graham Inggs ]
  * Drop globipack and optipack which have been empty for some time, thanks
    Lintian! (Closes: #1031964)

  [ Jochen Sprickerhof ]
  * Drop unused cmake defines

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 10 Mar 2023 08:13:22 +0100

trilinos (13.2.0-3) unstable; urgency=medium

  * Stop limiting to 2 parallel build jobs, thanks Adrian Bunk

 -- Graham Inggs <ginggs@debian.org>  Tue, 28 Jun 2022 12:52:43 +0000

trilinos (13.2.0-2) unstable; urgency=medium

  * Disable TBB for now, see #1011928

 -- Graham Inggs <ginggs@debian.org>  Sat, 25 Jun 2022 11:35:37 +0000

trilinos (13.2.0-1) unstable; urgency=medium

  [ Matthias Maier ]
  * New upstream release
  * Refresh patches
  * drop obsolete patches
  * use major.minor as SOVERSION and in package name and unify package naming

  [ Graham Inggs ]
  * libtrilinos-tpetra-dev: add missing Breaks+Replaces on
    libtrilinos-teuchos-dev (<< 13)
  * Enable build on riscv64

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Wed, 23 Feb 2022 21:20:43 +0000
